<?php
/**
 * Created by PhpStorm.
 * User: zhoujun
 * Date: 2020/10/13
 */
namespace App\Services\Util;

use Monolog\Logger;
use Monolog\Handler\StreamHandler;

class LogService
{
    private $logger;
    private $logName;

    const MAX_FILE_SIZE = 52428800;

    public function __construct()
    {
        $this->logName = date('Y-m-d') . '.log';
        $this->logger = new Logger('local');
    }

    public function getPath($group, $date)
    {
        return $group . '/' . $date . '.log';
    }

    public function getLogs($group)
    {
        $paths = \Storage::disk('logs')->files($group['folder']);
        $logs = [];
        foreach($paths as $path) $logs[] = $this->getLog($path);
        return collect($logs)->sortBy('timestamp')->reverse();
    }

    public function setGroup($name)
    {
        if(!file_exists(storage_path('/logs/'.$name))) $this->getCheckDir(storage_path('logs'),$name);
        $handles = [
            new StreamHandler(storage_path("/logs/$name/" . $this->logName))
        ];
        $this->logger->setHandlers($handles, Logger::INFO, false);
        return $this;
    }

    public function getCheckDir( $dir ,$folder){
        mkdir($dir.'/'.$folder,0775,true);
        chmod($dir.'/'.$folder,0775);
    }

    public function emergency($message, array $context = array())
    {
        $this->logger->emergency($message, $context);
    }

    public function alert($message, array $context = array())
    {
        $this->logger->alert($message, $context);
    }

    public function critical($message, array $context = array())
    {
        $this->logger->critical($message, $context);
    }

    public function error($message, array $context = array())
    {
        $this->logger->error($message, $context);
    }

    public function warning($message, array $context = array())
    {
        $this->logger->warning($message, $context);
    }

    public function notice($message, array $context = array())
    {
        $this->logger->notice($message, $context);
    }

    public function info($message, array $context = array())
    {
        $this->logger->info($message, $context);
    }

    public function debug($message, array $context = array())
    {
        $this->logger->debug($message, $context);
    }

}

?>
